paraMatrix - block requests based on domain and request type

Built atop the excellent project [xiMatrix](https://github.com/xi/xiMatrix) by Tobias Bengfort, itself influenced by Raymond Hill's [uMatrix](https://github.com/gorhill/uMatrix). paraMatrix blocks web requests via default-deny global default which can then whitelist elements on a per-site basis. For those who demand nothing less than granular control.

![screenshot](screenshot.png)

*~ "para- word-forming element of Latin origin meaning "defense, protection against; that which protects from."*

## Why use xiMatrix as a basis instead of uMatrix?

xiMatrix is simpler with a smaller codebase and is therefore more suitable to hack upon. It is already built in the spirit of 'do one thing and do it well' and implements some of the features I would have liked to see added to uMatrix. uMatrix covers things which may be considered outside the scope of a web request firewall such as spoofing values and managing local storage.

## Why not just contribute to xi's xiMatrix?

He has clearly stated in his project that it is a personal tool and will not likely be extended further. I will, however, try to track changes to xiMatrix to incorprate into paraMatrix. Although it may eventually be spun off as its own fork.

## In comparison to xiMatrix

-	Open to being extended
-	Separate image and media columns
-	Reload page button in-panel
-	~~Dark theme!~~ *(Mainlined, mostly)*
-	Dialog clarifications
-	More to come

## In comparison to uMatrix

-	Actively maintained
-	Smaller, simpler code
-	Rules encoded as JSON
-	Rows for managing inline scripts, styles, and images
-	Keyboard navigation
-	A column for blocking fonts

## TO DO

-	Display enumerated requests blocked in icon.
-	Placeholder element for blocked images/video.
-	Update in-place while keeping paraMatrix popup open.
-	Explicit deny option for cells.
-	Remove setting to disable request enumeration (performance impact is negligible).
-	Migrate help dialog to dedicated docs page.
